import matplotlib
matplotlib.use('Agg')
import matplotlib.pyplot as plt
plt.rcParams.update({'font.size': 18})
import numpy as np
import glob
import csv

mean_dense_1H = [1.0,1.0,1.0,0.03067538969120926,0.026976956506085677,0.03246592014899957,0.027527709285109062,0.03445660779678663,0.043510906026364364,0.03873717046756101,0.033426028022472055,0.036009720573434024,0.03897537245681319,0.04720438295074315,0.04142418508266183,0.05513901124346609,0.050766564961663437,0.05183062056841666,0.05149009820706404,0.0751997774014494,0.07528635932105794,0.1567983247891908,0.0739892525073868,0.48603156260685654,0.5171070205738553,0.36961332478511577,0.08238834540214482,0.06366908942189813,0.9312104199850707,0.10270118477566269,0.09076822984416179,0.1192057504616892]
mean_dense_2H = [1.0,1.0,1.0,1.0,0.03143486609268854,0.029435409845849234,0.0274455292613409,0.03117374917410573,0.0278557197201642,0.028927192741706756,0.027823413263545912,0.03207954230901595,0.04342771165893121,0.034597899525830846,0.043529935942870975,0.04215822014661335,0.051176190444743044,0.04539050040763616,0.04754019377057496,0.07937717108244165,0.12347788370489286,0.19222981745800374,0.0974670591315966,0.10234787769502907,0.1096590572744709,0.14187798037262156,1.0,0.17379160457885345,0.10341302391999362,0.09430662714482657,0.18347005740020808,0.11826843669703897]
mean_LSTM = [1.0,1.0,0.031666177357513516,0.029411869060927097,0.03186555744188947,0.03232900890771779,0.02888272466592028,0.02997623688789699,0.02761676153028936,0.03720456525249559,0.0326471292226263,0.035776271119278356,0.03350532448797419,0.0317876730335682,0.036931264917454104,0.0374146832052862,0.03589078007606806,0.0348880137255413,0.03132607549808651,0.03460454662867814,0.0278676788812628,0.03068778171654092,0.05010076828529745,0.03096930434543496,0.0631993120637093,0.03157486553196041,0.03401573624546892,0.05597066699050072,0.0774859532226534,0.05313533507268077,0.05156400872609053,0.056100807754709235]
mean_GRU = [1.0,0.02635753555674219,0.025541411225073526,0.02362126912106787,0.02713388834968664,0.0293753753105938,0.029282339920310787,0.03070213867505858,0.026509960457042098,0.02904529755455849,0.028359764572452734,0.029018482758800358,0.030022407210674288,0.030440767571734424,0.04190263684995954,0.03521213150797268,0.05486790293102681,0.07719006130169564,0.038760384758236274,0.06426683601915023,0.06439192025640299,0.08839593417805677,0.047323684446740844,0.04933518523284429,0.0638809268046307,0.06970387339653539,0.057246796722454724,0.03796830904929136,0.06989780586124378,0.10375425577853777,0.0809000112031632,0.053957954792303024]
mean_SimpleRNN = [1.0,1.0,1.0,0.03269670306750112,0.03496209093204193,0.034583737501076246,0.031310057053436605,0.02746865065595554,0.032271700666626275,0.031421449638272474,0.03010014534777773,0.026256799848022903,0.03154314747239997,0.033844948775005046,0.0317189272144487,0.035138379415323655,0.030922244894979675,0.03420265796708453,0.03834661876865319,0.06772688690871694,0.07789240793312983,0.05202266148121622,0.06599755443451773,0.08239533101289997,0.05391862795626505,0.0594610034240704,0.09608331127506442,0.08403103752445011,0.07260828372123652,0.07953187176416214,0.09012940044951158,0.06857662851041625]


std_dense_1H = [0.0,0.0,0.0,0.0239118229878,0.0199028425744,0.035465190679,0.0202640680938,0.0243672088934,0.0363684755179,0.0334975683245,0.033852317243,0.0439849047235,0.0403822315611,0.0419791215503,0.0388461280067,0.0565398972121,0.0458382143256,0.0421031389592,0.0416187234284,0.0729578754069,0.0659477143583,0.107855961048,0.0565921042919,0.296526074071,0.332291110328,0.243860200543,0.073948076103,0.0434163354681,0.150415653805,0.0850476174938,0.0709042239893,0.091970442578]
std_dense_2H = [0.0,0.0,0.0,0.0,0.018472880959,0.0208025708049,0.0234613924375,0.0250528762553,0.0240606122796,0.0230571071593,0.022909001572,0.0285522573602,0.0434301705373,0.0296014923709,0.0429739720288,0.0364413522643,0.0414285872984,0.0366540489555,0.0413440554964,0.0655594679073,0.0974456436503,0.171971421937,0.0952948462549,0.0738787657995,0.100012083793,0.118732706114,0.0,0.12460903303,0.10614467814,0.0734064956152,0.157521709952,0.0968489491008]
std_LSTM = [0.0,0.0,0.0198707677903,0.0186475966993,0.0201918204537,0.0197676353041,0.0201231758522,0.0196906805855,0.0195179392173,0.0306959950084,0.0223556256711,0.0270098111095,0.0253623579743,0.0205001223897,0.0258806100862,0.0273027462233,0.0275861844904,0.0288575214155,0.0256713268123,0.029898968462,0.0238413911727,0.0253574801374,0.0318521061224,0.0233228200351,0.0355934232632,0.0243395773029,0.0283720064293,0.0376787563868,0.0478102301606,0.0376253786681,0.0306190871046,0.0378407920614]
std_GRU = [0.0,0.0183418650093,0.0168775279585,0.0175635603615,0.0224115050715,0.0243939058203,0.0213089060268,0.0223407002811,0.0212406184639,0.0224772306018,0.0229391174972,0.023253053651,0.0269690883951,0.0248862072579,0.0380987424217,0.0245018032594,0.0425394527827,0.0504870671979,0.0290056056278,0.043173706605,0.0394422115705,0.0498352684062,0.0373124361451,0.0386919337503,0.0537512939658,0.0490963712934,0.0384186994071,0.0318657647145,0.0495159224262,0.0490471973568,0.0601543280386,0.0429043964405]
std_SimpleRNN = [0.0,0.0,0.0,0.0223450987086,0.027050648585,0.0286326312289,0.0210554938989,0.02267409481,0.0306358711117,0.0273816530995,0.025361807766,0.020533817307,0.0292135213901,0.030663466295,0.0253195537738,0.0354791361738,0.0260528353886,0.0306325685686,0.0345658366023,0.0472032836852,0.056399270988,0.0399039046085,0.0450580612515,0.0597915828856,0.0401716079365,0.0472636447358,0.0723627809031,0.0583405603962,0.0632068262643,0.0585190673764,0.0642593264418,0.0556892981349]

kurt_dense_1H = [10.3321622205,10.3321622205,10.3321622205,3.72199705988,6.38186227753,7.13068272707,3.89360844694,5.02420549415,6.64417413846,4.88042123097,0.809272060073,3.93409161477,3.98067063404,6.17984353655,5.0638351936,3.85182375087,4.25617540721,6.09571297636,6.82819578825,5.74916033712,5.29108184059,4.15257580253,6.79330126403,8.37907889437,8.66037920715,7.00593437811,6.34185565486,6.77662601783,1.71854583459,6.65652664197,7.16953483524,7.01252167951]
kurt_dense_2H = [10.3321622205,10.3321622205,10.3321622205,10.3321622205,5.28060821136,5.3341425071,5.6042576251,3.55573165832,0.376891520072,5.11109751979,4.26536976649,2.11235769171,3.49605008869,4.42818788,4.3950102219,5.79878687212,6.39573436111,6.33450200072,6.22408773047,7.68948775298,6.65364369343,7.3285561018,5.29864155237,6.38636247746,6.75140856951,7.55975800505,10.3321622205,7.68912560193,4.2847248426,6.98249072041,6.05974575176,7.22924645966]
kurt_LSTM = [10.3321622205,10.3321622205,7.3895993507,7.14731379403,8.16033730549,8.07744056962,8.79414947986,8.22245596346,6.36708101835,6.29165666731,4.23950222102,6.0404322051,7.60095373118,1.33963829837,7.24505222628,7.14598001032,7.46716045131,5.81569451105,5.98998121688,5.66868603266,3.99878919452,6.55704317719,6.18404908203,0.844882552848,3.00198806363,7.29888698417,3.11056491608,3.25969557673,5.17390904188,4.8185390004,6.12162098678,3.38600365532]
kurt_GRU = [10.3321622205,7.12624470623,6.7351474568,5.8571419535,1.84632507788,1.48832209718,4.0041067822,3.94418931445,2.03291335605,3.39817063237,1.8951649634,2.44923659939,4.19927239216,2.76434114179,5.25283767253,6.8205240724,3.36777854808,7.34406322535,7.1790639286,7.36361468776,6.96417736162,6.65000631874,5.86865701717,7.13063655929,6.89875377189,7.23315042214,6.63100411388,5.19651549991,7.81595337119,5.26771966455,6.60290630164,6.2629851712]
kurt_SimpleRNN = [10.3321622205,10.3321622205,10.3321622205,4.66980981093,3.77715386296,2.97041589534,6.37376293985,5.12649173682,1.74540377659,2.4796993292,3.97466882396,5.73713828003,0.689377941255,2.34469011859,1.73835200621,2.62877809594,5.48230086776,3.23620650279,3.14261509312,7.85591654902,7.52641479668,6.37882485875,7.48774540032,7.41072284895,7.4831452179,7.03980083635,7.05185987481,7.05542918111,6.27696557258,6.62184188899,7.17117997388,5.32331111287]

skew_dense_1H = [1.966666376,1.966666376,1.966666376,0.364272629626,4.06859413326,1.26278408825,2.2480638677,2.78057477415,2.36083782256,2.6455787176,1.01046100796,0.905918871767,2.90283522547,1.60474291981,1.40816978157,3.81034973801,2.28737009109,2.36597225607,1.83906561673,1.0221494192,1.16390821875,0.630673205263,1.81593892515,2.08642103315,1.99972759724,1.16717181147,1.21324894369,1.48202464522,0.500927055471,2.45298129857,2.34762266815,2.18562020899]
skew_dense_2H = [1.966666376,1.966666376,1.966666376,1.966666376,2.42210862578,2.35424280704,1.91144469918,2.91065213621,2.84836796463,1.82396530152,2.60654733122,2.67120585383,2.28507546128,1.45300165356,1.73088016153,2.19573329926,2.07401767165,2.32804108203,1.84566420854,1.83235003591,2.17398045004,2.66899303139,2.82882866801,1.35695544422,2.35955039204,2.37657601178,1.966666376,1.49640223921,3.54171065033,1.38881031216,3.0459168309,1.57862678707]
skew_LSTM = [1.966666376,1.966666376,1.03867427052,1.37898424805,1.24605319441,1.24451813639,1.7539425248,1.36251065672,3.07243720234,2.38313267172,2.40059191526,2.72690156639,2.0865480134,3.52021959961,2.31848720253,2.34707716645,1.71722157837,1.48774326385,1.58951986373,1.91258884013,1.29985079706,2.11490656973,1.59208199919,0.0752853506874,0.655066644556,1.99329375268,1.0587455386,0.810835039027,1.37152621687,1.31273875178,0.986477946646,1.01971355618]
skew_GRU = [1.966666376,1.20450935305,3.22140756787,2.48394492806,1.08531889857,1.53474486411,1.4410947317,1.69835594834,1.98229110871,1.10326824129,0.947760378725,2.35113409699,1.70869538725,2.06853412629,2.95740828455,2.27869803251,2.65144268215,2.33177617729,1.81560727001,1.55922070683,1.5118949467,1.41220793665,1.17582312763,2.09048218817,2.13606615902,2.01625620366,1.30617216767,2.08988061339,1.75752474905,1.19443539322,2.03237019271,1.92346636743]
skew_SimpleRNN = [1.966666376,1.966666376,1.966666376,0.374152337916,2.00790791378,1.70983017028,3.12552062214,2.30426714361,1.44059482754,2.69674644411,2.4195872897,2.25959951223,0.0182133561302,2.10781205238,1.56744078339,2.70933047474,2.29495654047,2.09798597337,1.93558375888,1.6787754351,2.06691231371,1.60947108806,1.89567748249,1.85416499317,1.65413535178,2.26150203288,1.90777859256,1.47732961715,1.9206152463,1.13082287253,1.90768749059,1.61182419003]

#mean_dense_1H = np.array(mean_dense_1H)

for i in [3,6,9,12,15,18,21,24,27,30]:
    print(str(kurt_dense_1H[i])+","+str(kurt_dense_2H[i])+","+str(kurt_LSTM[i])+","+str(kurt_GRU[i])+","+str(kurt_SimpleRNN[i]))

print("===============================================================================")

for i in [3,6,9,12,15,18,21,24,27,30]:
    print("\'"+str(i)+"\':"+"["+str(skew_dense_1H[i])+","+str(skew_dense_2H[i])+","+str(skew_LSTM[i])+","+str(skew_GRU[i])+","+str(skew_SimpleRNN[i]))+"]"


fig = plt.figure()
fig.set_figheight(8)
fig.set_figwidth(12)

x = range(1,len(mean_dense_1H)+1)

plt.subplot(1, 1, 1)
plt.errorbar(x, mean_dense_1H, yerr=std_dense_1H, fmt='o', label="Dense 1HL")
#plt.scatter(11, mean_dense_1H[11])
plt.errorbar(x, mean_dense_2H, yerr=std_dense_2H, fmt='o', label="Dense 2HL")
#plt.scatter(9, mean_dense_2H[9])
plt.errorbar(x, mean_LSTM, yerr=std_LSTM, fmt='o', label="LSTM")

plt.errorbar(x, mean_GRU, yerr=std_GRU, fmt='o', label="GRU")
plt.errorbar(x, mean_SimpleRNN, yerr=std_SimpleRNN, fmt='o', label="SimpleRNN")
plt.legend(loc="upper center", ncol=len(x), mode="expand", borderaxespad=0.)
plt.title('Mean Absolute Error (MAE) vs Number of Features')
plt.ylabel('MAE')

x_t = np.arange(1, len(x)+1, 5)
plt.xticks(x_t)
"""
plt.subplot(3, 1, 2)
plt.scatter(x, kurt_dense_1H)
plt.scatter(x, kurt_dense_2H)
plt.scatter(x, kurt_LSTM)
plt.scatter(x, kurt_GRU)
plt.scatter(x, kurt_SimpleRNN)
plt.ylabel('Kurtosis')

x_t = np.arange(1, len(x)+1, 5)
plt.xticks(x_t)

plt.subplot(3, 1, 3)
plt.scatter(x, skew_dense_1H)
plt.scatter(x, skew_dense_2H)
plt.scatter(x, skew_LSTM)
plt.scatter(x, skew_GRU)
plt.scatter(x, skew_SimpleRNN)
plt.xlabel('Number of Features')
plt.ylabel('Skew')

x_t = np.arange(1, len(x)+1, 5)
plt.xticks(x_t)
"""
plt.tight_layout()
fig.savefig("mae_vs_nf.png")

